package {

class TokenStream {

	var str:String;
	var offset:int=0;
	
	function TokenStream(s:String){
		str = s;
		skipSpace();
	}
	
  function readList():Array{
		var a:Array = new Array();
		while(true){
			if(eof()) break;
			var token:Object = readToken();
			if(token==null) break;
			a.push(token);
		}
		return a;
	}
	
	function readToken():Object{
		var s:String = next();
		var n:Number = Number(s);
		if(!isNaN(n)) return n;
		var first:String = s.charAt(0);
		if(first=="]") return null;
  	if(first=="[") return readList();
		return s;
	}
	
	
	function next():String{
  	if(peekChar()=='|') return readVbarString();
		var res:String="";
    if(delim()) res=nextChar();
    else {
      while(true){
        if(eof()) break;
        if(delim()) break;
        else res+=nextChar();
    }}
    skipSpace();
    return res;
  }

	function readVbarString():String{
		nextChar();
		var res:String="";
		while (true){
			var c:String=nextChar();
      if(eof()) return res;
			if(c=="|") {skipSpace(); return res;}
			res+=c;
		}
		return null;
	}
	
	
	function skipSpace():void{
    while(true){
    	if(eof()) return;
    	var c:String = peekChar();
//    	if(c==";"){skipToNextLine(); return;}
    	if(" \t\r\n,".indexOf(c)==-1) return;
    	nextChar();
    }	
	}

  function skipToNextLine():void{
    while(!eof()&&("\n\r".indexOf(peekChar())==-1)) offset++;
    skipSpace();
  }

  function nextLine():String{
    var res:String = "";
    while(!eof()&&(";\n\r".indexOf(peekChar())==-1)) res+=nextChar();
    skipSpace();
    return res;
  }

  function delim():Boolean{return "()[] \t\r\n".indexOf(peekChar())!=-1;}
  function peekChar():String {return str.charAt(offset);}
  function nextChar():String {return str.charAt(offset++);}
  function eof():Boolean {return str.length==offset;}	

}}
